import { AuthToken, Channel } from 'common/token';
export declare enum AccessTokenType {
    Bearer = "Bearer",
    Basic = "Basic"
}
export declare type AccessToken = {
    type: AccessTokenType;
    info: AccessInfo;
    grant?: boolean;
};
export declare type AccessInfo = {
    token: string;
    auth?: AuthToken;
    authMetadata?: BasicMetadata;
    headers?: {
        channel: Channel;
        localeCode: string;
    };
    requestedBy?: string;
};
export declare type BasicMetadata = {
    username: string;
    password: string;
    channel?: Channel;
};
export declare type Ability = {
    action: string;
    subject: string;
};
export declare type AuthBasicVerify = (params: BasicMetadata) => Promise<any>;
export declare type AuthDirective = {
    type: AccessTokenType;
    hasAbility?: Ability;
};
