"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.authBasicTokenMiddleware = void 0;
const auth_1 = require("../auth");
const http_auth_1 = require("./http-auth");
function authBasicTokenMiddleware(req, res, next) {
    const token = req.get('authorization');
    if (token && token.startsWith('Basic ')) {
        const auth = Buffer.from(token.replace('Basic ', ''), 'base64').toString('utf8');
        const loginInfo = auth.split(':');
        if (2 === loginInfo.length) {
            const accessToken = (0, http_auth_1.getAccessToken)(req) || { type: null, info: { token: null } };
            accessToken.type = auth_1.AccessTokenType.Basic;
            accessToken.info.token = token;
            accessToken.info.authMetadata = {
                username: loginInfo[0],
                password: loginInfo[1]
            };
            (0, http_auth_1.setAccessToken)(req, accessToken);
        }
    }
    return next();
}
exports.authBasicTokenMiddleware = authBasicTokenMiddleware;
//# sourceMappingURL=http-auth-basic.js.map