"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.authBearerTokenMiddleware = void 0;
const auth_1 = require("../auth");
const http_auth_1 = require("./http-auth");
function authBearerTokenMiddleware(req, res, next) {
    const token = req.get('authorization');
    if (token && token.startsWith('Bearer ')) {
        const accessToken = (0, http_auth_1.getAccessToken)(req) || { type: null, info: { token: null } };
        accessToken.type = auth_1.AccessTokenType.Bearer;
        accessToken.info.token = token;
        (0, http_auth_1.setAccessToken)(req, accessToken);
    }
    return next();
}
exports.authBearerTokenMiddleware = authBearerTokenMiddleware;
//# sourceMappingURL=http-auth-bearer.js.map