import Joi from 'joi';
import { Algorithm, BaseToken, JwtBaseToken } from './base-token';
export * from './base-token';
export declare type AuthRefreshToken = {
    userId: string;
} & BaseToken;
export declare const schemaAuthRefreshToken: {
    userId: Joi.StringSchema;
    kind: Joi.StringSchema;
    channel: Joi.StringSchema;
    iat: Joi.NumberSchema;
    exp: Joi.NumberSchema;
};
export declare class JwtAuthRefreshToken extends JwtBaseToken<AuthRefreshToken> {
    private static self;
    private constructor();
    static init(secret: string, algorithm: Algorithm): typeof JwtAuthRefreshToken;
    static term(): void;
    static sign(payload: AuthRefreshToken, expiresIn: string | number, notBefore?: string | number): string;
    static verify(token: string): AuthRefreshToken;
    private static get instance();
    static get isEnabled(): boolean;
}
