"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.JwtAuthRefreshToken = exports.schemaAuthRefreshToken = void 0;
const joi_1 = __importDefault(require("joi"));
const cm_libs_context_aware_error_1 = require("cm-libs-context-aware-error");
const base_token_1 = require("./base-token");
__exportStar(require("./base-token"), exports);
exports.schemaAuthRefreshToken = {
    ...base_token_1.schemaBaseToken,
    userId: joi_1.default.string().required()
};
class JwtAuthRefreshToken extends base_token_1.JwtBaseToken {
    constructor(secret, algorithm, schema) {
        super(secret, algorithm, schema);
    }
    static init(secret, algorithm) {
        this.self = new JwtAuthRefreshToken(secret, algorithm, joi_1.default.object(exports.schemaAuthRefreshToken));
        return this;
    }
    static term() {
        this.self = undefined;
    }
    static sign(payload, expiresIn, notBefore) {
        if (base_token_1.TokenKind.REFRESH_TOKEN !== payload.kind) {
            (0, cm_libs_context_aware_error_1.throwError)(cm_libs_context_aware_error_1.errors.INVALID_MESSAGE, 'Token kind is invalid', { token: payload });
        }
        return JwtAuthRefreshToken.instance.sign(payload, expiresIn, notBefore);
    }
    static verify(token) {
        const authRefreshToken = JwtAuthRefreshToken.instance.verify(token);
        /* istanbul ignore next */
        if (base_token_1.TokenKind.REFRESH_TOKEN !== authRefreshToken.kind) {
            (0, cm_libs_context_aware_error_1.throwError)(cm_libs_context_aware_error_1.errors.INVALID_MESSAGE, 'Token kind is invalid', { token: authRefreshToken });
        }
        return authRefreshToken;
    }
    static get instance() {
        return this.self || (0, cm_libs_context_aware_error_1.throwError)(cm_libs_context_aware_error_1.errors.NOT_INITIALIZED, 'JwtAuthRefreshToken initialization is required');
    }
    static get isEnabled() {
        return undefined !== this.self;
    }
}
exports.JwtAuthRefreshToken = JwtAuthRefreshToken;
//# sourceMappingURL=auth-refresh-token.js.map